<?php

require_once("db.inc.php");
require_once("utils.inc.php");
require_once("spacechem.class.php");


// Grab user file and a key to find a map to display.
$fpath= "000.user";
$key= mysql_real_escape_string(aget('key', $_GET, "4-6"));

main($fpath, $key);

// -----------------------------------------------------------------------------
// FUNCTIONS
// -----------------------------------------------------------------------------

function main($fpath, $key)
{
	scRenderMap($fpath, $key);
}

//! Load and render a spacechem overworld map.
function scRenderMap($fpath, $key)
{
	$ldb= new SQLite3($fpath, SQLITE3_OPEN_READONLY);
	
	$res= mysql_query("SELECT * FROM `maps` WHERE `key`='$key'") or die(mysql_error());
	$map= mysql_fetch_assoc($res);

	htmlBegin(array(
		'title' => "{$map['key']} &ndash; {$map['name']}", 
		'css' => array('spacechem.css')
	));
	
	$scm= new spaceChemMap();
	if($scm->load($ldb, $key))
	{
		$url= "";
		echo "<h2><a href=\"$url\">{$map['key']} &ndash; {$map['name']}</a></h2>";
		echo $scm->render();
	}

	htmlEnd();
}

//! Remove ALL undo info. Seriously reduces the savegame's filesize.
function scKillUndo($fpath)
{
	$ldb= new SQLite3($fpath);

	$res= $ldb->query("DELETE FROM `Undo`");
	$res= $ldb->query("DELETE FROM `UndoPtr`");
	$res= $ldb->query("VACUUM");
	
	//# TODO: return the file for download.
}

// -----------------------------------------------------------------------------
// TEST FUNCTIONS
// -----------------------------------------------------------------------------

function test($fpath, $key)
{
	$ldb= new SQLite3($fpath, SQLITE3_OPEN_READONLY);
	
	$res= mysql_query("SELECT * FROM `maps` WHERE `key`='$key'") or die(mysql_error());
	$map= mysql_fetch_assoc($res);

	htmlBegin(array(
		'title' => "{$map['key']} &ndash; {$map['name']}", 
		'css' => array('spacechem.css')
	));
	
	test_scMap($ldb, $key);
	// scKillUndo(fpath);
	
	htmlEnd();
}


function test_scMap($ldb, $key)
{
	$scm= new spaceChemMap();
	
	if($scm->load($ldb, $key))
	{
		$url= "";
		// --- dummy links to solutionnet ---
		$lut= array(
			'3-5'	=> "http://spacechem.net/solution/nothing-works/1849",
			'4-6'	=> "http://spacechem.net/solution/no-need-for-introductions/8057", 
			'6-5'	=> "http://spacechem.net/solution/more-than-machine/6933",
			'7-6'	=> "http://spacechem.net/solution/don%27t-fear-the-reaper/15178",
		);
		
		$map= $scm->map();
		$url= (isset($lut[$key]) ? $lut[$key] : "");
		
		// --- actual output ---
		
		echo htmlTable($scm->buildings());
		echo <<<DOC
<h2>
  <a href="$url">
    {$map['key']} &ndash; {$map['name']}
  </a>
</h2>
DOC;
		echo $scm->render();
	}
}

// -----------------------------------------------------------------------------
// UTILITIES
// -----------------------------------------------------------------------------

// Get all results from a sqlite query as a matrix.
function ldbQueryAll($ldb, $query)
{
	$res= $ldb->query($query);
	$a= array();
	while($row = $res->fetchArray(SQLITE3_ASSOC))
		$a[]= $row;
		
	return $a;
}

?>
